using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
  using System.Text.RegularExpressions;
using System.Threading;
using System.Diagnostics;
namespace SNspider
{
    public partial class Form1 : Form
    {
        int levels;
        string[] exclusions;



        public Form1()
        {
            InitializeComponent();

            exclusions = new string[4];
            exclusions[0] = "\\Application Data\\";
            exclusions[1] = "\\windows\\";
            exclusions[2] = "@";
            exclusions[3] = "Cookies";
        }
           /*callback methods for ui */

        private void updateProgress()
        {
            this.progressBar1.Value++;
        }
        private void addResult(String match, String filename)
        {

            if (cbExcludeSysDir.Checked == true)
            {
             foreach(String s in exclusions)
                 if(filename.Contains(s))
                     return;



            }
            listBox2.Items.Add("Found (" + match + ") in file \"" + filename+"\"");
        }
        private void removeTop(ref LinkedList<string> list)
        {
            list.RemoveFirst();
        }

        public delegate void updateProgressCALLBACK();
        public delegate void addResultCALLBACK(String match, String filename);
        public delegate void removeTopCALLBACK(ref LinkedList<string> list);

        /**********************************/



        private void button2_Click(object sender, EventArgs e)
        {
            /*used for adding folders to spider's search*/
            FolderBrowserDialog FBD = new FolderBrowserDialog();
            FBD.ShowDialog();
            if (!(FBD.SelectedPath == ""))
                listBox1.Items.Add(FBD.SelectedPath);

        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            /*search is designed to search the root of a drive, but if
             * a full blown directory is selected, the tooltip will reflect the currently
             * selected item */

                if(listBox1.SelectedIndex>0)
                toolTip.SetToolTip(this.listBox1, listBox1.Items[listBox1.SelectedIndex].ToString());
        }

        private void btnRmDir_Click(object sender, EventArgs e)
        {
            /*remove selected directory if any*/
            listBox1.Items.Remove(listBox1.SelectedItem);
        }

        private void btnRun_Click(object sender, EventArgs e)
        {
            DateTime start;
            DateTime finish;
            String filter = ".txt;.msg;.doc";
        
            progressBar1.Value = 0;
            /*first off if no directories are selected exit*/
            if (listBox1.Items.Count == 0)
            {
                MessageBox.Show("You didnt select any directories to search!");
                return;
            }
    
            /*Logic for crawling starts here.  Threading will be
             * enabled at some point, and instead of typical 'blocking' activity
             * it works basically by each thread picking up any remaining
             * work to do and returning to the available pool once its done.
             * a thread can pull work from the pool.  Seems that it would
             * create a race condition, but its fine as there is reading only, no writing.*/

            int maxThreads = (int) numericUpDown2.Value;
            int filecount = 0;
            int resultcount = 0;
            LinkedList<string> files = new LinkedList<string>();
            LinkedList<Regex> patterns = new LinkedList<Regex>();


            //****section to determine what to search**/
            // Just adds whatever is to be searched for to a linklist of search items.
            // not the most efficient, but whatever
            if (cbCCNO.Checked == true)
            {         patterns.AddFirst(new Regex("((4\\d{3})|(5[1-5]\\d{2})|(6011))-?\\d{4}-?\\d{4}-?\\d{4}|3[4,7]\\d{13}$"));
            
            }
            if (cbSSN.Checked == true)   //*social security numbers */
            {
                patterns.AddFirst(new Regex("\\d{3}-\\d{2}-\\d{4}"));
                patterns.AddFirst(new Regex("\\d{9}( |\\n)*"));
            }
            if (cbPhoneNO.Checked == true)    /*phone numbers*/
            {
                patterns.AddFirst(new Regex("(\\()?(\\d{3}[- \\.])?(\\))?\\d{3}[ -\\.]\\d{4}"));
            }
            if (cbIPV4.Checked == true)
            {
                patterns.AddFirst(new Regex("\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}( |\\n)"));
            }
            if (cbEmail.Checked == true)
            {
                patterns.AddFirst(new Regex("[A-Za-z0-9_.]*@[A-Za-z0-9_.-]*.[a-zA-z]"));
            }
            if (cbAppPWD.Checked == true)
            {
                patterns.AddFirst(new Regex("(pass|password|pass word|pwd)[ :=]*['\"]*(\\n| )['\"]*")); 
            }
            if (cbPIN.Checked == true)
            {

            }
            if (cbVIN.Checked == true)
            {
            }
            if (cbLOGON.Checked == true)
            {
                patterns.AddFirst(new Regex("(username|user|usr)[ :=]*(\\n| )")); 
            }


            if (patterns.Count == 0)
            {
                MessageBox.Show("You have to select search criteria!");
                return;
            }




            /*all prerequisites checked so we can continue*/
            btnRun.Enabled = false;
            btnRun.Text = "Scanning...";
            listBox2.Items.Clear();
    
         
            //**********************************************//


            /*get a list of all files that satisfy initial search criteria
             and pass over a list to store it in directly.*/
            foreach (string loc in listBox1.Items)
            {
                levels = 0;
                fileScan(loc, filter, ref files);
                filecount += files.Count;
                logging.writeLog("" + files.Count + " files.");


               }

               progressBar1.Maximum = files.Count;
               progressBar1.Value = 0;



            /*create an asynchronous thread to search so that the app doesnt freeze,
             * if need be, the user can specify that up to 8 threads search simultaneously
             * however we want to avoid thrashing the disk.  Later versions might spread
             * threads across multiple drive letters, however there is no guarantee, that 
             * two driveletters dont reside on the same disk*/
               
            
            ThreadStart t1 = delegate { deepSearch(patterns,ref files); };

              
               
                   Thread[] t = new Thread[maxThreads];
                   for (int i = 0; i < maxThreads; i++)
                   {
                       t[i] = new Thread(t1);
                       t[i].Start();
                       t[i].Join(10); /*join the thread back and update the ui while stuff is happening*/
                   }
              

            start = DateTime.Now;
           
                   while (this.progressBar1.Value < this.progressBar1.Maximum-1)
                   {      Application.DoEvents();
                   
                            Thread.Sleep(10);
                   }
                   resultcount = listBox2.Items.Count+1;
                   finish = DateTime.Now;
                 
                 
                       MessageBox.Show("finished. went through "+filecount+" files in "+(finish-start)+".  found: "+resultcount+" records");
                       btnRun.Enabled = true;      
            btnRun.Text = "Go!";
        }



       /*method solely to retrieve all files
        *from some directory that match a
        *criteria.  after this is done
        *then work is done to act on those files seperate file types with a ;,
        do not use wildcards*/
              private void fileScan(String sDir,string pattern,ref LinkedList<string> list)
        {
            levels = 0;
            for (int j = 0; j < sDir.Length; j++)
                if (sDir[j] == '\\')
                    levels++;
                 if(levels>=numericUpDown3.Value)
                     return;
                  
                  
                  String[] patterns = pattern.Split(';');
      
        /*dredge the root of the drive first, then once we have files
         * already skip this part*/
       
              
                  if(list.Count ==0)
                      try
                      {
                          foreach (string e in Directory.GetFiles(sDir))
                          {
                              foreach (String s in patterns)
                              {

                                  if (e.Contains(s))
                                  {
                                      list.AddLast(e);
                                  }
                              }

                          }
                      }
                      catch (System.Exception excpt)
                      {

                          logging.writeLog(excpt.Message);
                      
                      }
                  
                  try
                  {
                      foreach (string d in Directory.GetDirectories(sDir))
                      {
                      
                          try
                          {
                              foreach (string f in Directory.GetFiles(d))
                              {
                                  foreach (String s in patterns)
                                  {

                                      if (f.Contains(s))
                                      {
                                          list.AddLast(f);
                                      }
                                  }      
                              }
                          }
                          catch (System.Exception excpt)
                          {

                              logging.writeLog(excpt.Message);

                          }
                   
                          fileScan(d, pattern,ref list);
                      }
                  }
                  catch (System.Exception excpt)
                  {

                    logging.writeLog(excpt.Message);

                  }


}
             
        
        /*this is designed to be called from a thread! pass the list of expressions to search for, and 
         * a pointer to the list of files to search for, and each thread will take from that list until
         * there are none left.*/
        private void deepSearch(LinkedList<Regex>searches, ref LinkedList<String> file)
        {
    
            if (file == null)
                return ;
            String filename;
            while (file.Count > 0)
            {

           //   MessageBox.Show(file.First.Value);
        
                
                try
                {              
                    lock (this)
                    {
                        filename = file.First.Value;
                       this.Invoke(new removeTopCALLBACK(this.removeTop), new object[] { file });
                     //   file.RemoveFirst();
                      }
                 //   MessageBox.Show(filename);
                    StreamReader SR = new StreamReader(filename);
                       
                    String contents = SR.ReadToEnd();
                    SR.Close();
                //    progressBar1.Value++;

                    progressBar1.Invoke(new updateProgressCALLBACK(this.updateProgress), new object[] { });
                  
 

                    foreach (Regex r in searches)
                    {
                        // MessageBox.Show(""+r.Matches("112-45-6789").Count);

                        MatchCollection mc = r.Matches(contents);

                        foreach (Match m in mc)
                        {
                            listBox1.Invoke(new addResultCALLBACK(this.addResult), new object[] { m.Value, filename });
                        }
                    }
                }
                catch (System.Exception excpt)
                {

                    logging.writeLog(excpt.Message);

                }
          
            }
        }

        /*set the tooltip the the selected item so that the user can see it all easily*/
        private void listBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
             if (listBox2.SelectedIndex > 0)
                toolTip.SetToolTip(this.listBox2, listBox2.Items[listBox2.SelectedIndex].ToString());

        }
        /*just here to move the order of the search item up or down, no biggie*/


        /*just here to move the order of the search item up or down, no biggie*/
        private void btnUP_Click(object sender, EventArgs e)
        {
            int i = listBox1.SelectedIndex;
            if (listBox1.Items.Count > 1 && i > 0)
            {

                Object temp;
                temp = listBox1.Items[i - 1];
                listBox1.Items[i - 1] = listBox1.Items[i];
                listBox1.Items[i] = temp;
                listBox1.SetSelected(i - 1, true);

            }
        }
        private void btnDown_Click(object sender, EventArgs e)
        {
            int i = listBox1.SelectedIndex;
            if (listBox1.Items.Count > 1 && i < listBox1.Items.Count-1)
            {

                Object temp;
                temp = listBox1.Items[i + 1];
                listBox1.Items[i + 1] = listBox1.Items[i];
                listBox1.Items[i] = temp;
                listBox1.SetSelected(i+1, true);
            }


        }

        /*attempts to open folder containing selected item*/
        private void butnOpenFold_click(object sender, EventArgs e)
        {
              if (listBox2.SelectedIndex >= 0)
            {
                Process p = new Process();
                string[] target = listBox2.SelectedItem.ToString().Split('\"');

                 string folder = target[1].Substring(0,target[1].LastIndexOf('\\'));
                p.StartInfo.FileName = folder;
            p.Start();
                // p.StartInfo.Arguments = listBox1.Items[listBox1.SelectedIndex].ToString().Substring(
            }
            else { MessageBox.Show("No item selected!"); }
        


        }

        /*attempts to open selected file*/
        private void butnOpenFile_Click(object sender, EventArgs e)
        {
            if (listBox2.SelectedIndex >= 0)
            {
                Process p = new Process();
                string[] target = listBox2.SelectedItem.ToString().Split('\"');

                p.StartInfo.FileName = target[1];
            p.Start();
             
            }
            else { MessageBox.Show("No item selected!"); }
        }

        /*exports the results to a text file*/
        private void btnExport_Click(object sender, EventArgs e)
        {
            if (listBox2.Items.Count == 0)
            {
                MessageBox.Show("No data!");
                return;
            }
            SaveFileDialog SFD = new SaveFileDialog();
            SFD.Title = "Choose a location to save log";
            SFD.Filter = "Text files(*.txt)|*.txt";
            SFD.ShowDialog();
            if (SFD.FileName != "")
            {

                StreamWriter sw = new StreamWriter(SFD.FileName);
                foreach (string s in listBox2.Items)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
            }
        }

        private void cbCCNO_CheckedChanged(object sender, EventArgs e)
        {

        }



    }

}